#define XstepPin 10
#define XdirPin 7
#define Xopto 8

#define YstepPin 2
#define YdirPin 3
#define Yopto 4

#define ZstepPin 19
#define ZdirPin 18
#define Zopto 17

#define EnableSteppers 15

#include "WProgram.h"
void setup();
void loop();
void print_opto();
void setup()
{
  Serial.begin(9600);
  Serial.println("Starting stepper exerciser.");

  pinMode(XstepPin, OUTPUT);
  pinMode(XdirPin, OUTPUT);
  pinMode(Xopto, INPUT);
  
  pinMode(YstepPin, OUTPUT);
  pinMode(YdirPin, OUTPUT);
  pinMode(Yopto, INPUT);  
 
  pinMode(ZstepPin, OUTPUT);
  pinMode(ZdirPin, OUTPUT);
  pinMode(Zopto, INPUT);
  
  pinMode(EnableSteppers, OUTPUT);

  digitalWrite(XdirPin, LOW);
  digitalWrite(XstepPin, LOW);
  
   digitalWrite(YdirPin, HIGH);
  digitalWrite(YstepPin, LOW);
  
   digitalWrite(ZdirPin, LOW);
  digitalWrite(ZstepPin, LOW);
  
    digitalWrite(EnableSteppers, HIGH);
  Serial.print("Starting Z, Zopto=");
 Serial.println(digitalRead(Zopto));
  while(digitalRead(Zopto))
  {
        print_opto;
        digitalWrite(ZstepPin, HIGH);
        delayMicroseconds(2);
        digitalWrite(ZstepPin, LOW);
        delayMicroseconds(1650);
  }
  
  
 Serial.print("Starting Y, Yopto=");
 Serial.println(digitalRead(Yopto));
  while(digitalRead(Yopto))
  {
        print_opto;
        digitalWrite(YstepPin, HIGH);
        delayMicroseconds(2);
        digitalWrite(YstepPin, LOW);
        delayMicroseconds(1650);
  }
  
  Serial.print("Starting X, Xopto=");
  Serial.println(digitalRead(Xopto));
  while(digitalRead(Xopto))
  {
        print_opto;
        digitalWrite(XstepPin, HIGH);
        delayMicroseconds(2);
        digitalWrite(XstepPin, LOW);
        delayMicroseconds(1650);
  }
  digitalWrite(EnableSteppers, LOW);  
}

void loop()
{
  //    delay(1000);
   //   Serial.println("Switching directions."); 
//      digitalWrite(dirPin, !digitalRead(dirPin));
}

void print_opto()
{
  Serial.print("Z=");
  Serial.print(digitalRead(Zopto));
  Serial.print("  Y=");
  Serial.print(digitalRead(Yopto));
  Serial.print("  X=");
  Serial.println(digitalRead(Xopto));
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

