#define XstepPin 10
#define XdirPin 7
#define Xopto 8

#define YstepPin 2
#define YdirPin 3
#define Yopto 4

#define ZstepPin 19
#define ZdirPin 18
#define Zopto 17

#define EnableSteppers 15

#include "WProgram.h"
void setup();
void loop();
void setup()
{
  Serial.begin(9600);
  Serial.println("Starting stepper exerciser.");

  pinMode(XstepPin, OUTPUT);
  pinMode(XdirPin, OUTPUT);
  pinMode(Xopto, INPUT);
  
  pinMode(YstepPin, OUTPUT);
  pinMode(YdirPin, OUTPUT);
  pinMode(Yopto, INPUT);  
 
  pinMode(ZstepPin, OUTPUT);
  pinMode(ZdirPin, OUTPUT);
  pinMode(Zopto, INPUT);
  
  pinMode(EnableSteppers, OUTPUT);

  digitalWrite(XdirPin, LOW);
  digitalWrite(XstepPin, LOW);
  
   digitalWrite(YdirPin, LOW);
  digitalWrite(YstepPin, LOW);
  
   digitalWrite(ZdirPin, LOW);
  digitalWrite(ZstepPin, LOW);
  
  digitalWrite(EnableSteppers, LOW);
}
void loop()
{
  Serial.print("Z=");
  Serial.print(digitalRead(Zopto));
  Serial.print("  Y=");
  Serial.print(digitalRead(Yopto));
  Serial.print("  X=");
  Serial.println(digitalRead(Xopto));
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

