#define XstepPin 10
#define XdirPin 7
#define Xopto 8

#define YstepPin 2
#define YdirPin 3
#define Yopto 4

#define ZstepPin 19
#define ZdirPin 18
#define Zopto 17

#define EnableSteppers 15

#include "WProgram.h"
void setup();
void loop();
void setup()
{
  Serial.begin(9600);
  Serial.println("Starting stepper exerciser.");

//----------------------------------------------------------
  pinMode(XstepPin, OUTPUT);
  pinMode(XdirPin, OUTPUT);
  pinMode(Xopto, INPUT);
  
  pinMode(YstepPin, OUTPUT);
  pinMode(YdirPin, OUTPUT);
  pinMode(Yopto, INPUT);  
 
  pinMode(ZstepPin, OUTPUT);
  pinMode(ZdirPin, OUTPUT);
  pinMode(Zopto, INPUT);
  
  pinMode(EnableSteppers, OUTPUT);

  digitalWrite(XdirPin, LOW);
  digitalWrite(XstepPin, LOW);
  
   digitalWrite(YdirPin, HIGH);
  digitalWrite(YstepPin, LOW);
  
   digitalWrite(ZdirPin, LOW);
  digitalWrite(ZstepPin, LOW);
//------------------------------------------------------------------------------------  
  digitalWrite(EnableSteppers, HIGH);
  int i,j,size,margin;
  size=800;
  margin=5;
  for (i=size;i>=0;i-=margin)
  {
    
    //------------------------------------------------------------------------------------  
      digitalWrite(XdirPin, !digitalRead(XdirPin));      
      for (j=0;j<i;j++)
      {
          digitalWrite(XstepPin, HIGH);
          delayMicroseconds(2);
          digitalWrite(XstepPin, LOW);
          delayMicroseconds(1650);
      }
      //------------------------------------------------------------------------------------  
      digitalWrite(YdirPin, !digitalRead(YdirPin));
       for (j=0;j<i;j++)
      {
          digitalWrite(YstepPin, HIGH);
          delayMicroseconds(2);
          digitalWrite(YstepPin, LOW);
          delayMicroseconds(1650);
      }
      Serial.println(i);
  }
        digitalWrite(EnableSteppers, LOW);  
}
void loop()
{

}



int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

